/*-
 * ax25.h
 */

#define	MAXDIGIS	7	/* Maximum number of digipeaters */
#define	AXALEN		7	/* Total AX.25 address length, including SSID */
#define PACLEN		256	/* Max length of info */

struct axhdr {
	struct ax_addr ah_dst;
	struct ax_addr ah_src;
	u_char ah_ctrl;
	u_char ah_pid;
};

#define AXMINLEN	(2 * AXALEN + 1)

#define SSID_H		0x80		/* repeated bit */
#define SSID_C		0x80		/* command/response bit */
#define SSID_XXX	0x60		/* 0110 0000 */
#define SSID		0x1e		/* SSID bits */
#define SSID_E		0x01		/* last address bit */

#define COMMAND		0
#define RESPONSE	1

#define NR			0xe0
#define PF			0x10
#define NS			0x0e

#define INFO		0x00	/* Information */
#define RR			0x01	/* Receiver ready */
#define RNR			0x05	/* Receiver not ready */
#define REJ			0x09	/* Reject */
#define SABM		0x2f	/* Set asynch. balanced mode */
#define DISC		0x43	/* Disconnect */
#define DM			0x0f	/* Disconnected mode */
#define UA			0x63	/* Unnumbered acknowledge */
#define FRMR		0x87	/* Frame reject */
#define UI			0x03	/* Unnumbered information */


#define AXTYPE_SEG	0x08	/* Segmented packet, used with LAPB */
#define AXTYPE_IP	0xcc	/* Internet Protocol */
#define AXTYPE_ARP	0xcd	/* ARP */
#define AXTYPE_NR	0xcf	/* Net/Rom */
#define AXTYPE_NOL3	0xf0	/* Good Old Packet */

#define SEG_FIRST	0x80	/* First segment bit */
#define SEG_REM		0x7f	/* Mask for remaining segments */

#define AX25_LINGERTIME 60

#ifdef KERNEL
extern struct ax_addr ax_broadcastaddr;
#endif

